# Todo list

## High priority

- [ ] add balanced growth path handling
- [ ] more options for IRFs, pass on shock vector, simulate only certain shocks
- [ ] write tests and documentation for solution, estimation... making sure results are consistent
- [ ] use @assert for errors and @test_throws
- [ ] add other outputs from estimation (smoothed, filter states and shocks)
- [ ] print SS dependencies, show SS solver
- [ ] write to dynare
  
- [ ] speed up 2nd moment calc for large models. maybe its only the derivatives but its slow for SW03
- [ ] make the nonnegativity trick optional
- [ ] get parameters (in function of parameters) into the dependencies
- [ ] for larger models write a model compression. gradient loglikelihood is very slow due to large matmuls
- [ ] see if we can avoid try catch and test for invertability instead
- [ ] use packages for kalman filter
- [ ] input field for SS init guess in all functions
- [ ] clean up different parameter types
- [ ] clean up printouts/reporting
- [ ] clean up function inputs and harmonise AD and standard commands
- [ ] figure out combinations for inputs (parameters and variables in different formats for get_irf for example)
- [ ] write documentation/docstrings
- [ ] add more models
- [ ] symbolic derivatives
- [ ] plot multiple solutions or models - multioptions in one graph
- [ ] Find any SS by optimising over both SS guesses and parameter inputs
- [ ] have Flux solve SS field
- [ ] check control flow in SS solver
  
- [x] add plot for policy function
- [x] add plot for FEVD
- [x] add functions like get_variance, get_sd, get_var, get_covar
- [x] add correlation, autocorrelation, and (conditional) variance decomposition
- [x] go through docs to reflect verbose behaviour
- [x] speed up covariance mat calc
- [x] have conditional parameters at end of entry as well (... | alpha instead of alpha | ...)
- [x] Get functions: get_output, get_moments
- [x] get rid of init_guess
- [x] an and schorfheide estimation
- [x] estimation, IRF matching, system priors
- [x] check derivative tests with finite diff
- [x] release first version
- [x] SS solve: add domain transformation optim
- [x] revisit optimizers for SS
- [x] figure out licenses
- [x] SS: replace variables in log() with auxilliary variable which must be positive to help solver
- [x] complex example with lags > 1, [ss], calib equations, aux nonneg vars
- [x] add NLboxsolve
- [x] try NonlinearSolve - fails due to missing bounds
- [x] make noneg aux part of optim problem for NLboxsolve in order to avoid DomainErrors - not necessary
- [x] have bounds on alpha (failed previously due to naming conflict) - works now

## Not high priority

- [ ] estimation codes with missing values (adopt kalman filter)
- [ ] whats a good error measure for higher order solutions (taking whole dist of future shock into account)? use mean error for n number of future shocks
- [ ] implement global solution methods
- [ ] improve redundant calculations of SS and other parts of solution
- [ ] restructure functions and containers so that compiler knows what types to expect
- [ ] use RecursiveFactorization and TriangularSolve to solve, instead of MKL or OpenBLAS
- [ ] fix SnoopCompile with generated functions
- [ ] rewrite first order with riccati equation MatrixEquations.jl
- [ ] exploit variable incidence and compression for higher order derivatives
- [ ] for estimation use CUDA with st order: linear time iteration starting from last 1st order solution and then LinearSolveCUDA solvers for higher orders. this should bring benefits for large models and HANK models
- [ ] test on highly [nonlinear model](https://www.sciencedirect.com/science/article/pii/S0165188917300970)
- [ ] pull request in StatsFuns to have norminv... accept type numbers and add translation from matlab: norminv to StatsFuns norminvcdf
- [ ] more informative errors when declaring equations/ calibration
- [ ] unit equation errors
- [ ] implenent reduced linearised system solver + nonlinear
- [ ] implement HANK
- [ ] implement automatic problem derivation (gEcon)
- [ ] print legend for algorithm in last subplot of plot only
- [ ] conditional forecasting
- [ ] select variables for moments

- [x] find way to recover from failed SS solution which is written to init guess
- [x] redo ugly solution for selecting parameters to differentiate for
- [x] conditions for when to use which solution. if solution is outdated redo all solutions which have been done so far and use smart starting points
- [x] Revise 2,3 pert codes to make it more intuitive
- [x] implement blockdiag with julia package instead of python
- [x] Pretty print linear solution
- [x] write function to get_irfs
- [x] Named arrays for irf
- [x] write state space function for solution
- [x] Status print for model container
- [x] implenent 2nd + 3rd order perturbation
- [x] implement fuctions for distributions
- [x] try speedmapping.jl - no improvement
- [x] moment matching
- [x] write tests for higher order pert and standalone function
- [x] add compression back in
- [x] FixedPointAcceleration didnt improve on iterative procedure
- [x] add exogenous variables in lead or lag
- [x] regex in parser of SS and exo
- [x] test SS solver on SW07
- [x] change calibration, distinguish SS/dyn parameters
- [x] plot multiple solutions at same time (save them in separate constructs)
- [x] implement bounds in SS finder
- [x] map pars + vars impacting SS
- [x] check bounds when putting in new calibration
- [x] Save plot option
- [x] Add shock to plot title
- [x] print model name
